% Simulated e_1^TA^{-1}b_{p+1},e_1^TA^{-1}b_{p+2}
% To prove for odd p, the values of the efficient of the terms O(h^{p+1}), O(h^{p+2}) 
% is 0, but not zero for even p
% 

function eab=bias(p)
v1=zeros(p,1);
A=zeros(p,p);
b1=zeros(p,1);
b2=zeros(p,1);
for i=1:p
    F=@(x) (x.^i.*epan(x));
    v1(i)=quadl(F,-1,1);
end

for i=1:p
    for j=1:p
    F=@(x) (x.^(i+j).*epan(x));
        A(i,j)=quadl(F,-1,1)-v1(i).*v1(j);
    end
end

for i=1:p
   F=@(x) (x.^(p+1).*(x.^i-v1(i)).*epan(x));
   b1(i)=quadl(F,-1,1);
end

eab=inv(A)*b1;
eab1=eab(1);

for i=1:p
   F=@(x) (x.^(p+2).*(x.^i-v1(i)).*epan(x));
   b2(i)=quadl(F,-1,1);
end
eab=inv(A)*b2;
eab2=eab(1);

eab=[eab1 eab2];

function y = epan(x);
% Computes the epan kernel
% Usage : y = epan(x);
% Returns: y = (3/4).*(x.*x.<1).*(1- x.*x) ) ;
%
i = (x.*x < 1) ;
x = x .*i ;
y = (3/4) * i .* (1- x.*x) ;
%y=exp(-x.^2/2)/sqrt(2*pi);
