function [a,A1]=chiv_real_data(v,Yijmr,p,rj0,h)

% Function chiv.m 
% To comupting \hat{\chi}(v) and \hat{s}(v)
% For a given grid points v - q*1 vector, to find \hat{\rho}_{j1}(X_{ij},v)
% p-- the dimension of \beta
% v=(v_1,...,v_q)
% Output: a -q*p matrix, for \hat{\chi}(v)
%         A1 -q*1 vector for \tilde{A}_1(v), for our simulations and real
%         data analysis q=1

global W Z V Delta;
[n,J]=size(Z);
q=length(v);
a=zeros(q,p);
s=zeros(q,p);
Aj1=zeros(n,J,q);

myfj=permute(repmat(fj(v),[1 1 n]),[3 2 1]);
estrhoj0=rhoj0(v,Yijmr,h);
estrhoj1=rhoj1(v,Yijmr,h);
estrhoj2=rhoj2(v,Yijmr,h);
estrhoj10=estrhoj1./estrhoj0;

Aj1=estrhoj2./estrhoj0-estrhoj10.^2;
temp=repmat(Delta,[1 1 q])./repmat(rj0,[1 1 q]);
temp1=estrhoj0.*myfj.*temp;
A1=Aj1.*temp1;
A1=mean(A1,1);
A1=sum(squeeze(A1),1);  % q*1 vector for \tilde{A}_k(v)

estwrhoj0=wrhoj0(v,Yijmr,p,h);
estwrhoj1=wrhoj1(v,Yijmr,p,h);

for d=1:p
	Bj=(estwrhoj1(:,:,:,d)-estrhoj10.*estwrhoj0(:,:,:,d))./estrhoj0;
	B=Bj.*temp1;
	B=mean(B,1);
	B=sum(squeeze(B),1);   % q*1
	a(:,d)=-(B./A1)';
end



