function [sigma,sigmader]=est_sigmader(z)
% estimating derivative of \sigma(z)
% Input: z-- a column vector
% Using the local linear smoother

global Z Delta h;
J=size(Z);
J=J(2);
z0=linspace(0,1,20); % the grid points over which g() is estimated
lam=zeros(J,length(z0));
lamder=zeros(J,length(z0));
for j=1:J
[lam(j,:),lamder(j,:)]=loc_linear_der(Delta(:,j),Z(:,j),h,z0');  % Estimating E[\Delta_{1j}|Z_{ij}=zgrid]
end
sigma=1./sum(lam);   % \hat{\sigma}(zgrid)
sigmader=-sigma.^2.*sum(lamder);  % \hat{\sigma}'(zgrid), with f_j(z)=1
sigmader=interp1(z0,sigmader,z,'linear'); 
sigma=interp1(z0,sigma,z,'linear');