%  Real data analysis, 
% Programmed by Jiancheng Jiang, Aug. 28, 2004 at UNC-CH

clear;
close all;
format long;
global Z X Delta W zgrid h hopt;

fid = fopen('Fhsdata.dat');
a = fscanf(fid,'%g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g',[23 inf]); % It has 14 rows now.
a = a';
fclose(fid);
%a=a(1:50,:);
X=a(:,[12,17]);
Delta=a(:,[11,16]);
Z00=a(:,5); 
W0=a(:,[3,4,6,9,10,21]);
display('Number of Z less than 20');
sum(Z00>360)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[n,J]=size(X);
[n,p]=size(W0);      % p-number of beta parameters
W=zeros(n,J,p); 
W(:,1,:)=W0;
W(:,2,:)=W0;
Z0=(Z00-min(Z00))/range(Z00);  % rescale the Z-variable
Z=repmat(Z0,1,2);
z0=linspace(0,1,20); % the grid points over which g() is estimated
hopt=3/8*n^(-1/7); %  the bandwidth for estimating g'()
h=3/8*n^(-1/3);    %  the bandwidth for estimating \beta
lz0=length(z0);  
ebeta=zeros(p,lz0);
gderiv=zeros(2,lz0);
beta=zeros(p,1);
vargder=zeros(length(z0),1);
beta0=beta+0.2;
alpha0=[beta0' 0 4]'; % initial parameters values
[gtj,ddj,dd2j]=gtt(z0);
     for j=1:lz0
      zgrid=z0(j);
      alpha0(end-1)=ddj(j);
      alpha0(end)=dd2j(j);
      [ebeta(:,j),gderiv(:,j)]=max_loc_ell_real(alpha0);  % estimating \beta and g at point zgrid, naive estimator of \beta and g'()
     end
gz0=trap(z0',gderiv(1,:)');           % using the Trapezoidal Rule to calculate integration, a row vector
gz1=interp1(z0,gz0,Z,'linear');  % linear interpolation for g() at Z, --a matrix n*J, naive estimator of g()
hatbeta0=mean(ebeta');           % naive estimator of \beta
    epsi=1;
    while (epsi>0.001)
    global g;
    g=gz1;                       % estimator of g() at Z_{ij}, naive estimator of g() at Z_{ij}
    hatbeta1=max_global_ell(hatbeta0);      % estimated \beta by global partial likelihood maximization, in Step 3
    global beta0;
    beta0=hatbeta1;
       h0=h;
       h=hopt;  
       for j=1:lz0
       zgrid=z0(j);
       gderi0=gderiv(:,j);  % initial value of g'() at z0(j)
       gderiv(:,j)=max_loc_ell_1(gderi0);
       end
       h=h0;
    gz0=trap(z0',gderiv(1,:)');             % using the Trapezoidal Rule to calculate integration, a row vector
    gz1=interp1(z0,gz0,Z,'linear');    % linear interpolation for g() at Z, --a matrix n*J, naive estimator of g()
    epsi=mean(abs(hatbeta1-hatbeta0)); %+mean(abs(gz1-g));
    hatbeta0=hatbeta1;
    end
[estomega,naomega,cross_corr]=omega(hatbeta0,gz1);       % function called: to compute the \hat{\Omega}
eststdbeta=sqrt(estomega/n);           % \beta's asymptotic variance
for j=1:lz0
    vargder(j)=var_gder(hatbeta0,gz1,z0(j),hopt);
end
CI_UP_gder=gderiv(1,:)+1.96*sqrt(vargder');
CI_LOW_gder=gderiv(1,:)-1.96*sqrt(vargder');
estbeta_pvalue=1-chi2cdf((abs(hatbeta0./eststdbeta')).^2,1);

display('Estimated Parameters beta:=');
hatbeta0
display('Estimated Standard Error for beta:=');
eststdbeta'
display('P-values');
estbeta_pvalue
z0=min(Z00)+z0*range(Z00);
ratio_cens=mean(mean(Delta));
display('Ratio of censoring');
1-ratio_cens
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%% Output plots %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pstr='fhs';
figure(1);close
clf;

z=z0(1:(end-5))
gz=gz0(1:(end-5));
gzderiv=gderiv(1,1:(end-5));
zCI_UP_gder=CI_UP_gder(1:(end-5));
zCI_LOW_gder=CI_LOW_gder(1:(end-5));

plot(z,gz,'k-');
set(gca,'fontsize',20);
%axis([min(z0)-2,max(z0)+2,-3,1.5]);
xlabel('Cholesterol');
axis([min(z0)-20,370,-0.5,1.5]);
title('Estimated function g') 
orient portrait;
%set(gcf,'PaperSize',[4.0,4.0]);
%set(gcf,'PaperPosition',[0.25,0.25,4.0,4.0]);
print('-deps', [pstr,'_g.eps']);

figure(2);close
clf;
plot(z,gzderiv,'k-');
set(gca,'fontsize',20);
%axis([min(z0)-2,max(z0)+2,-3,15]);
xlabel('Cholesterol');
axis([min(z0)-20,370,-3,5]);
hold on
plot(z,zCI_UP_gder,'k-.');
hold on
plot(z,zCI_LOW_gder,'k-.');
title('Estimated derivative function of g')
orient portrait;
%set(gcf,'PaperSize',[4.0,4.0]);
%set(gcf,'PaperPosition',[0.25,0.25,4.0,4.0]);
print('-deps', [pstr,'_gder.eps']);  


