%  Real data analysis, 
% Programmed by Jiancheng Jiang, Aug. 28, 2004 at UNC-CH

clear;
close all;
format long;
global T Z X Delta W V vgrid h hopt p alphaV;

fid = fopen('fhsdata.dat');
a = fscanf(fid,'%g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g %g',[23 inf]); % It has 14 rows now.
a = a';
fclose(fid);
%a=a(1:200,:);
X=a(:,[12,17]);
Delta=a(:,[11,16]);
Z0=a(:,5); %cholestrol
W0=a(:,[3,4,6,9,10,21]);
V00=a(:,4);%bmi
display('Number of V greater than 45');
sum(V00>45)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[n,J]=size(X);
[n,p]=size(W0);      % p-number of beta parameters
W=zeros(n,J,p); 
W(:,1,:)=W0;
W(:,2,:)=W0;
Z=repmat(Z0,1,2);
V0=(V00-min(V00))/range(V00);  % rescale the Z-variable in [0,1]
V=repmat(V0,1,2);
v0=linspace(0,1,20); % the grid points over which g() is estimated
hopt=2*3/8*n^(-1/7); %  the bandwidth for estimating g'()
h=2*3/8*n^(-1/3);    %  the bandwidth for estimating \beta
lv0=length(v0);  
ebeta=zeros(p,lv0);
gderiv=zeros(2,lv0);
beta=zeros(p,1);
vargder=zeros(length(v0),1);
beta0=beta+0.2;
alpha00=[beta0' 0 4]'; % initial parameters values

[alpha,alphad,alphad2]=falpha(v0);
     for j=1:lv0
      vgrid=v0(j);
      alpha00(p+1)=alpha(j);
      alpha00(end)=alphad(j);
      [ebeta(:,j),egamma(:,j)]=max_loc_ell(alpha00);  % estimating \beta and \alpha at point vgrid, naive estimator of \beta and \alpha()
     end
alpha=interp1(v0',egamma(1,:),V,'spline');  % linear interpolation for alpha1() at V, --a matrix n*J, naive estimator of alpha()
hatbeta0=mean(ebeta');           % naive estimator of \beta
    epsi=1
    while (epsi>0.01)
    alphaV=alpha.*Z;                       % estimator of alpha() at V_{ij}, naive estimator of alpha() at V_{ij}
    hatbeta1=max_global_ell(hatbeta0);      % estimated \beta by global partial likelihood maximization, in Step 3
    global beta0;
    beta0=hatbeta1;
       h0=h;
       h=hopt;                   % using hopt to estimate the alpha and its derivative
       for j=1:lv0
       vgrid=v0(j);
       gamma0=egamma(:,j);        % initial value of alpha() and alpha' at v0(j)
       [egamma(:,j)]=max_loc_ell_1(gamma0);
       end
       h=h0;
    alpha=interp1(v0',egamma(1,:),V,'spline');    % linear interpolation for alpha() at V, --a matrix n*J, naive estimator of alpha()
    epsi=mean(abs(hatbeta1-hatbeta0))%+mean(abs(alpha1-alpha01))+mean(abs(alpha2-alpha02));
    hatbeta0=hatbeta1;
    end
 ealpha=egamma(1,:);
[estomega,naomega,cross_corr]=omega(hatbeta0,alphaV);     % function called: to compute the \hat{\Omega} and its first term
eststdbeta=sqrt(estomega/n);           % \beta's asymptotic variance
estbeta_pvalue=1-chi2cdf((abs(hatbeta0./eststdbeta')).^2,1);

display('Estimated Parameters beta:=');
hatbeta0
display('Estimated Standard Error for beta:=');
eststdbeta'
display('P-values');
estbeta_pvalue
v0=min(V00)+v0*range(V00);
ratio_cens=mean(mean(Delta));
display('Ratio of censoring');
1-ratio_cens
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pstr='fhs_2';


v=v0(1:(end-2));
ealphav=ealpha(1:(end-2));

figure(1);close  % to use the matlab Batch mode on unix to yield graphs
clf;
set(gca,'fontsize',20);
plot(v,ealphav,'k-','LineWidth',1);
%axis([27,46,-0.05,0.09]);
xlabel('BMI');
title('Estimated function \alpha(\cdot)') 
orient portrait;
print('-deps', [pstr,'.eps']);





