function [dens]=fj(v)
% to find a consistent estimator of the density of V_{1j}
% all vectors are column vector if not declared
% Kernel density estimation for V,  
% Name:  fj.m
% function called: kx.m
% Output: q*J matrix

global V;
v=linspace(0,1,20)';  % grid points for estimation for Uniform [0,1], which can be changed as a parameter
[n,J]=size(V);                         % samples size
m=length(v);                           % number of grid points 
dens=zeros(m,J);

for j=1:J 
x=V(:,j);
h=1.06*std(x)*n^(-0.2);              % pilot bandwidth, we just need a consistent estimator of the density
xz=repmat(x,1,m)-repmat(v',n,1);       % a n*m matrix
xz1=repmat(x,1,m)+repmat(v',n,1);      % a n*m matrix
kxxizh=epan(xz./repmat(h,n,m));        % a n*m matrix
kxxizh1=epan(xz1./repmat(h,n,m));      % a n*m matrix
kxxizh=(kxxizh-kxxizh1)./repmat(h,n,m);
dens(:,j)=max(1,mean(kxxizh)');               % a column vector: m*1
end

%fv1=interp1(v,dens(:,1),V(:,1));
%fv2=interp1(v,dens(:,2),V(:,2));
%fv=[fv1,fv2];
return