function [T,X,Delta,Z,W,V]=gdatag1(n,J,beta,theta,vtype,zparam,ctype,cparam,stoptime);
% Input: 
% 
% vtype indicates the distribution for V
%               0=N(0,1),1=uniform(0,1))
% ctype indicates the distribution for censoring (0=exponential,1=uniform,
%                                                 9=no censoring)
% zparam -- the probability of success for binormial r.v. Z if ztype=1
% cparam -- the parameter of exponential dist
% stoptime --the stop time for censoring, i.e. the maximum of censoring time

% generating confounding covariates with binomial, uniform and normal distribution;
global p;
W=zeros(n,J,p); 
Z=zeros(n,J);

if (p==3)
  W(:,:,1)=(unifrnd(0,1,n,J)>=zparam);
  W(:,:,2)=randn(n,J);
  W(:,:,3)=unifrnd(0,1,n,J);
elseif (p==2)
  W(:,:,1)=(unifrnd(0,1,n,J)>=zparam);  
  W(:,:,2)=unifrnd(0,1,n,J); 
else
  dispaly('Error: to adjust code for p here');
end

%%%%%%%%%%%%%%%%%% should be removed if don't need correlation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% to yield correlation between covariates within each cluster
%W(:,2,1)=W(:,1,1);  
%W(:,:,2)=W(:,:,2)*[1 0.8;0 0.2];
%W(:,:,3)=W(:,:,3)*[1 0;0.5 sqrt(3)/2];  % to make correlation coef be 0.5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% generate the main exposure variable.
%  if (vtype == 0) V = randn(n,J);end
%  if (vtype == 1) V = unifrnd(0,1,n,J);end
V=squeeze(W(:,:,p)); 

% generate covariate Z
%Z(:,:,1)=(unifrnd(0,1,n,J)>=zparam);  
%Z(:,:,2)=randn(n,J); 
Z=randn(n,J);

 % generating failure time from clayton model;
 a=1;
 while (a>0)
 T = local_clayton1(n,J,Z,W,V,theta,beta); % generating the survival time T_{ij} from Clayton model;
 a=sum(sum(isnan(T)));
 end
	
% generating censoring time C_{ij}
  if (ctype == 0) cc = matrix(rexp(n*J,cparam),n,J);end
  if (ctype == 1) cc = unifrnd(0,cparam,n,J);end
  if (ctype == 9) 
     X = T;
     Delta = ones(n,J);
  else 
     cc = min(cc,stoptime);
	 X=min(T,cc);                          % generating the observed survival time X_{ij}
     Delta=(T<=cc);                         % generating the censoring index \Delta_{ij}
  end
return


