function [s]=hats(v,Yijmr,p,rj0,rj10,hatX,h)

% Function chiv_etaj.m 
% To comupting \hat{\chi}(v) and \hat{s}(v)
% For a given grid points v - q*1 vector, to find \hat{\rho}_{j1}(X_{ij},v)
% p-- the dimension of \beta
% v=(v_1,...,v_q)
% Output: a -q*p matrix, for \hat{\chi}(v)
%         s -q*p matrix, for \hat{eta}_j

global Z V Delta;
[n,J]=size(Z);
q=length(v);
s=zeros(q,p);
Aj1=zeros(n,J,q);

myfj=permute(repmat(fj(v),[1 1 n]),[3 2 1]);
estrhoj0=rhoj0(v,Yijmr,h);
estrhoj1=rhoj1(v,Yijmr,h);
estrhoj2=rhoj2(v,Yijmr,h);
estrhoj10=estrhoj1./estrhoj0;

Aj1=estrhoj2./estrhoj0-estrhoj10.^2;
temp=repmat(Delta,[1 1 q])./repmat(rj0,[1 1 q]);
temp1=estrhoj0.*myfj.*temp;
A1=Aj1.*temp1;
A1=mean(A1,1);
A1=sum(squeeze(A1),1)';  % q*1 vector

est_tilde_rj1=tilde_rj1(v,Yijmr,p,hatX,h);   %n*J*q*p
estwrhoj0=wrhoj0(v,Yijmr,p,h);
estwrhoj0=wrhoj1(v,Yijmr,p,h);
rj10=repmat(rj10,[1 1 1 q]);

for d=1:p
	etaj=myfj.*(squeeze(est_tilde_rj1(:,:,:,d))-squeeze(rj10(:,:,d,:)).*estrhoj1)./squeeze(permute(repmat(A1,[1 n J]),[2 3 1]));
    sj=etaj.*temp;
	sj=mean(sj,1);
    s(:,d)=sum(squeeze(sj),1)';
end



