function [mhat]=loc_const(y,x,h,ingrid)
% all vectors are column vector if not declared
% Local constant Regressionwith given local bandwidths at ingrid   
% Model: y_i=m(x_i)+e_i
% Name:  loc_const.m
% input: y-a vector,x-a vector,ingrid-a vector for estimation grid points, 
%        h-a vector(a column vector), must be the same size as ingrid
% function called: kx.m
% output: mhat, the estimated value of m(x) at ingrid, a row vector
% designed by Jiancheng Jiang, July 01, 2001 at CUHK
n=length(y);                          % samples size
m=length(ingrid);                     % number of grid points 
xz=repmat(x,1,m)-repmat(ingrid',n,1); % a n*m matrix
kxxizh=epan(xz./repmat(h',n,1));     % a n*m matrix
sn0=sum(kxxizh);
mhat=sum(kxxizh.*repmat(y,1,m))'./sn0'; % a column vector----mhat
return
