%function [hatbeta0,ealpha,estomega,naomega,cross_corr]=main_temp(i,n,J,beta,theta,vtype,zparam,ctype,cparam,stoptime,v0,p,nsim)
% The main function body for simulations, to release the memory when loops

function [hatbeta0,ealpha,estomega,naomega,cross_corr]=main_temp(i,n,J,beta,theta,vtype,zparam,ctype,cparam,stoptime,v0,nsim)

global T Z X V Delta W vgrid h hopt p alphaV;
lv0=length(v0);  
ebeta=zeros(p,lv0);
alpha00=[beta' 0 0]'; % initial parameters values for \beta and (\alpha,\alpha')
[T,X,Delta,Z,W,V]=gdatag(n,J,beta,theta,vtype,zparam,ctype,cparam,stoptime);    %generating obs.
[alpha,alphad,alphad2]=falpha(v0);
     for j=1:lv0
      vgrid=v0(j);
      alpha00(p+1)=alpha(j);
      alpha00(end)=alphad(j);
      [ebeta(:,j),egamma(:,j)]=max_loc_ell(alpha00);  % estimating \beta and \alpha at point vgrid, naive estimator of \beta and \alpha()
     end
alpha=interp1(v0',egamma(1,:),V,'spline');  % linear interpolation for alpha1() at V, --a matrix n*J, naive estimator of alpha()
hatbeta0=mean(ebeta');           % naive estimator of \beta
    epsi=1;
    while (epsi>0.01)
    alphaV=alpha.*Z;                       % estimator of alpha() at V_{ij}, naive estimator of alpha() at V_{ij}
    hatbeta1=max_global_ell(hatbeta0);      % estimated \beta by global partial likelihood maximization, in Step 3
    global beta0;
    beta0=hatbeta1;
       h0=h;
       h=hopt;                   % using hopt to estimate the alpha and its derivative
       for j=1:lv0
       vgrid=v0(j);
       gamma0=egamma(:,j);        % initial value of alpha() and alpha' at v0(j)
       [egamma(:,j)]=max_loc_ell_1(gamma0);
       end
       h=h0;
    alpha=interp1(v0',egamma(1,:),V,'spline');    % linear interpolation for alpha() at V, --a matrix n*J, naive estimator of alpha()
    epsi=mean(abs(hatbeta1-hatbeta0));%+mean(abs(alpha1-alpha01))+mean(abs(alpha2-alpha02));
    hatbeta0=hatbeta1;
    end
 ealpha=egamma(1,:);
[estomega,naomega,cross_corr]=omega(hatbeta0,alphaV);     % function called: to compute the \hat{\Omega} and its first term
return
%--------------------------------------------------------------------------
