% Function for computing the coef beta and the function g() in the model (5), naive estimation
% Name: max_loc_ell.m
% Input:alpha0-- initial values of theta
%
% Output: beta--the estimated \beta for coef of W at different grid points for z_0, a column vector with length the same as zgrid
%         gamma----the estimated function alpha(.) at grid points z=zgrid, a column vector with length the same as zgrid
%
% Functions called: loc

function [beta,gamma]=max_loc_ell(alpha0)
global Z X Delta W vgrid h p;
%option=optimset('TolFun',1e-3,'MaxIter',300,'MaxFunEvals',300);
%myalpha =fminsearch(@loc_ell,alpha0,option);
myalpha =fminsearch(@loc_ell,alpha0);
beta=myalpha(1:p);
gamma=myalpha((p+1):end);   % estimated alpha() and alpha' at grid point v_0=vrid
return