function [est_rhoj0]=rhoj0(v,Yijmr,h)
% For a given grid points v, to find \hat{\rho}_{j0}(X_{ij},v) and its
% derivative
% v=(v_1,...,v_q)
% Output: n*J*q array, the (i,j,k) element, \hat{\rho}_{j0}(X_{ij}|v_k) 

global V;
[n,J]=size(V);
q=length(v);
est_rhoj0=zeros(n,J,q);
for j=1:J
    for i=1:n
    [est_rhoj0(i,j,:)]=loc_linear(Yijmr(:,j,i),V(:,j),h(:,j),v);  % using local linear smoother to get the conditional expectation estimation
    end
end
return

