function est_rhom=rhom(z,Yijmr,rj10,p)
% For a given scalar z, to find \hat{\rho}_m(X_{\ell m},z)
% Output: n*J*p matrix, the (i,j) element of the sth component of
% \hat{\rho}_j(X_{ij},z) for s=1,...,p

global X W Z;
[n,J]=size(X);
est_rhom=zeros(n,J,p);
Id=(0>z).*(z>Z)-(0<z).*(z<Z);  % compute ID(z,Z)
Id=repmat(Id,[1 1 n]);
for s=1:p
    W0=repmat(W(:,:,s),[1 1 n])-permute(repmat(rj10(:,:,s),[ 1 1 n]),[3 2 1]); % the (l,m,i) element
eest_rhom=W0.*Yijmr.*Id;
eest_rhom=mean(eest_rhom,1);  
est_rhom(:,:,s)=squeeze(eest_rhom)';       % n*J matrix, \hat{\rho}_j(X_{ij},z)'s the sth component
end
return
