function [vargder]=var_gder(beta,gz,z0,h)
% function: find estimation of the variance of \hat{g}'(z) for $z=z0$
% Input: beta- the estimated bate value
%        gz- the estimated g() at Z
%        z0- the point for which the variance of  g'(z0) is evaluated
%        h-  the bandwidth used

global Z X Delta W;
[n,J]=size(X);
p=length(beta);
Yijm=(repmat(X,[1,1,n])>=permute(repmat(X,[1 1 n]),[3,2,1]));  % n*J*n array: the (i,j,m) element is Y_{ij}(X_{mj})
Wb=0;
    for i=1:p
       Wb=Wb+W(:,:,i)*beta(i);      % find $beta^T W_{ij}$, a single n*J matrix
    end
r=repmat(exp(Wb+gz),[1 1 n]);  
Yijmr=Yijm.*r;
rj0=mean(Yijmr,1);  
rj0=squeeze(rj0)'; % the (m,j) element of r_{j0}(X_{mj}), a matrix of n*J

Fij=zeros(n,J);
W0=permute(repmat(Delta,[1 1 n]),[3 2 1]).*permute(Yijmr,[3 2 1])./repmat(rj0,[1 1 n]); % the (m,j,i) element
Kh0=epan((Z-z0)/h)/h;

    W2=permute(repmat((Z-z0)/h,[1 1 n]),[3 2 1]); % the (m,j,i) element
    Kh=permute(repmat(Kh0,[1 1 n]),[3 2 1]);
    W1=mean(W0.*W2.*Kh,1);
    W1=squeeze(W1)';  % a matrix of n*J whose element is the (i,j) element of the second term of \hat{G}_{ij}
    Fij=(Z-z0)/h.*Delta.*Kh0-W1;  % F_{ij}, n*J matrix
 
    W1=mean(repmat(Fij,[1 1 J]).*permute(repmat(Fij,[1 1 J]),[1 3 2]),1);
    W1=squeeze(W1);
    estsigma=sum(sum(W1));   % \hat{\Sigma}
  
sigma1=sum(mean(Delta.*Kh0,1));
vargder=estsigma/sigma1^2/n/h;  % the estimated variance of \hat{g}'(z0)
return
